// Used to decode DMX signals to control addressable RGB LEDs
// Made by: Chad Tuinstra

#include <DMXSerial.h>   // get the libary at:  https://github.com/mathertel/DMXSerial  by: mathertel 
#include <FastLED.h>

int startAddress = 0 * 3 + 1; 
const int OutPin =  12;  // output pin for RGB data.
// inputs from the dip switches
const int Input2 = 2;  
const int Input3 = 3;  
const int Input4 = 4;  
const int Input5 = 5;  
const int Input6 = 6;  
const int Input7 = 7; 
const int Input8 = 8;   
const int Input9 = 9; 
const int Input10 = 10; 
const int Input11 = 11; 

int Dip1 = 0;
int Dip2 = 0;
int Dip3 = 0;
int Dip4 = 0;
int Dip5 = 0;
int Dip6 = 0;
int Dip7 = 0;
int Dip8 = 0;
int Dip9 = 0;
int Dip10 = 0;  // reserved for option

int LEDLIMIT;


#define LED_QTY         57      // Number of LEDs in strip
#define BRIGHTNESS      255     // brightness range [0..255]
#define CHIP_SET       WS2812B  // types of RGB LEDs
#define COLOR_CODE      GRB     // sequence of colors in data stream

// Define the array of LEDs
CRGB LEDs[LED_QTY];

void setup() {
  DMXSerial.init(DMXReceiver);
  FastLED.addLeds<CHIP_SET, OutPin, COLOR_CODE>(LEDs, LED_QTY);
  FastLED.setBrightness(BRIGHTNESS);
  FastLED.setMaxPowerInVoltsAndMilliamps(5, 5000);
  FastLED.clear();
  FastLED.show();
  //pinMode(LED_BUILTIN, OUTPUT); // used during testing
  pinMode(OutPin, OUTPUT);
  pinMode(Input2, INPUT_PULLUP);
  pinMode(Input3, INPUT_PULLUP);
  pinMode(Input4, INPUT_PULLUP);
  pinMode(Input5, INPUT_PULLUP);
  pinMode(Input6, INPUT_PULLUP);
  pinMode(Input7, INPUT_PULLUP);
  pinMode(Input8, INPUT_PULLUP);
  pinMode(Input9, INPUT_PULLUP);
  pinMode(Input10, INPUT_PULLUP);
  pinMode(Input11, INPUT_PULLUP);

    // translate the dip switches inputs into a number
 if (digitalRead(Input2) == HIGH) {Dip1 = 0;}
 if (digitalRead(Input2) == LOW)  {Dip1 = 1;}

 if (digitalRead(Input3) == HIGH) {Dip2 = 0;}
 if (digitalRead(Input3) == LOW)  {Dip2 = 2;}

 if (digitalRead(Input4) == HIGH) {Dip3 = 0;}
 if (digitalRead(Input4) == LOW)  {Dip3 = 4;}

 if (digitalRead(Input5) == HIGH) {Dip4 = 0;}
 if (digitalRead(Input5) == LOW)  {Dip4 = 8;}

 if (digitalRead(Input6) == HIGH) {Dip5 = 0;}
 if (digitalRead(Input6) == LOW)  {Dip5 = 16;}

 if (digitalRead(Input7) == HIGH) {Dip6 = 0;}
 if (digitalRead(Input7) == LOW)  {Dip6 = 32;}

 if (digitalRead(Input8) == HIGH) {Dip7 = 0;}
 if (digitalRead(Input7) == LOW)  {Dip7 = 64;}

 if (digitalRead(Input9) == HIGH) {Dip8 = 0;}
 if (digitalRead(Input9) == LOW)  {Dip8 = 128;}

 if (digitalRead(Input10) == HIGH) {Dip9 = 0;}
 if (digitalRead(Input10) == LOW)  {Dip9 = 256;}

 if (digitalRead(Input11) == HIGH) {Dip10 = 1;}
 if (digitalRead(Input11) == LOW)  {Dip10 = 0;}

 //startAddress = Dip1 + Dip2 + Dip3 + Dip4 + Dip5 + Dip6 + Dip7 + Dip8 + Dip9; // set the startAddress 
 //if (startAddress < 1) startAddress = 1;  // if no DIP is active, set to 1
 startAddress = 1;  // for testing

 }

void loop() {
  unsigned long lastPacket = DMXSerial.noDataSince();

  if (lastPacket < 5000) {  //Read recent DMX values and set levels
    if (Dip10 = 1) {        //Enter program info here for option 10
      LEDLIMIT = DMXSerial.read(startAddress + 3);  // use the fourth channel as option
      LEDLIMIT = map(LEDLIMIT, 0, 255, 0, LED_QTY);  // to limit the height of the LED bar
    }
       
    //for (int i = 0; i < LED_QTY; i++)
    for (int i = 0; i < LEDLIMIT; i++)
    LEDs[i] = CRGB(DMXSerial.read(startAddress), DMXSerial.read(startAddress + 1), DMXSerial.read(startAddress + 2));
    FastLED.show();
    FastLED.clear();
    delay (50);  //required to prevent running too fast and causing blinking
    
  } else {

    }
}

// End.
